<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/HashMD5.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_hash_m_d5_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">HashMD5.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;HashMD5.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;boost/uuid/detail/md5.hpp&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    constexpr <span class="keywordtype">size_t</span> getMD5Size ()</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    {</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;        constexpr <span class="keywordtype">size_t</span> <span class="keyword">const</span> size = <span class="keyword">sizeof</span>(boost::uuids::detail::md5::digest_type); <span class="comment">// size of MD5 (in Bytes)</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;        <span class="keywordflow">return</span> size;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    }</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="structsiggen_1_1_hash_m_d5.html#ac19394e2a1c3fba563445469b8b5399c">   13</a></span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="structsiggen_1_1_hash_m_d5.html#ac19394e2a1c3fba563445469b8b5399c">HashMD5::GetSignatureSize</a> ()<span class="keyword"> const</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">    </span>{</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keywordflow">return</span> getMD5Size();</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    }</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="structsiggen_1_1_hash_m_d5.html#aa40f031d6beb761a413ac1c116d79298">   18</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="structsiggen_1_1_hash_m_d5.html#aa40f031d6beb761a413ac1c116d79298">HashMD5::CalculateSignature</a> (<span class="keywordtype">char</span> <span class="keyword">const</span> * data, <span class="keywordtype">size_t</span> size, <span class="keywordtype">char</span> * digest)<span class="keyword"> const</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">    </span>{</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="comment">// calculate md5 signature</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        boost::uuids::detail::md5 hash;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        boost::uuids::detail::md5::digest_type md5_digest;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        hash.process_bytes(data, size);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        hash.get_digest(md5_digest);</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordtype">char</span> <span class="keyword">const</span> * <span class="keyword">const</span> digest_begin = reinterpret_cast&lt;char const *&gt;(md5_digest);</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="comment">// store output</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        LOGBUFF(<span class="stringliteral">&quot;Block signature (md5): &quot;</span>, digest_begin, getMD5Size());</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        memcpy(digest, digest_begin, getMD5Size());</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    }</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;} <span class="comment">// namespace siggen</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="astructsiggen_1_1_hash_m_d5_html_aa40f031d6beb761a413ac1c116d79298"><div class="ttname"><a href="structsiggen_1_1_hash_m_d5.html#aa40f031d6beb761a413ac1c116d79298">siggen::HashMD5::CalculateSignature</a></div><div class="ttdeci">virtual void CalculateSignature(char const *data, size_t size, char *digest) const final</div><div class="ttdoc">calculates signature of the block of data</div><div class="ttdef"><b>Definition:</b> <a href="_hash_m_d5_8cpp_source.html#l00018">HashMD5.cpp:18</a></div></div>
<div class="ttc" id="astructsiggen_1_1_hash_m_d5_html_ac19394e2a1c3fba563445469b8b5399c"><div class="ttname"><a href="structsiggen_1_1_hash_m_d5.html#ac19394e2a1c3fba563445469b8b5399c">siggen::HashMD5::GetSignatureSize</a></div><div class="ttdeci">virtual size_t GetSignatureSize() const final</div><div class="ttdoc">returns size of the signature</div><div class="ttdef"><b>Definition:</b> <a href="_hash_m_d5_8cpp_source.html#l00013">HashMD5.cpp:13</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>HashMD5.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
